//MorphDriver v1.0
//written by faulknermano, Lernie Ang

@warnings
@script channel
@define SCRIPTNAME "Morph Driver v1"
selObj;
selChannel = 1;
value = 0.0;
channelNames;
min = 0.0;
mid = 45.0;
max = 90.0;
chan;
targetValue;
a1;
c1..4;
e1..3;
midState = false;
overshootState = false;
v;
curtime;
targetName;
selChannel;
targetValue;
targetID;
meshName;
freshload;

save: what, io
{
	if(what == SCENEMODE)
	{
		if(selObj)
			saveTargetID = selObj.id;
		else
			saveTargetID = "nil";
		if(selObj.genus == BONE)
		{
			a = selObj.parent;
			while(a.genus == BONE)
				a = a.parent;
			meshName = a.name;
		}
		else
			meshName = "nil";
		io.writeln(meshName);
		io.writeln(saveTargetID);
		io.writeln(selChannel);
		io.writeln(overshootState);
		io.writeln(midState);
		io.writeln(min);
		io.writeln(mid);
		io.writeln(max);
	}
}

load: what, io
{
	if(what == SCENEMODE)
	{
		mName = io.read();
		if(mName == "nil")
			meshName = nil;
		else
			meshName = string(mName);
		tID = io.read();
		if(tID == "nil")
			targetID = nil;
		else
			targetID = integer(tID);
		selChannel = integer(io.read());
		overshootState = integer(io.read());
		midState = integer(io.read());
		min = integer(io.read());
		mid = integer(io.read());
		max = integer(io.read());
	}
	freshload = true;
}
	
destroy
{
	if(reqisopen())
		reqend();
}
create: channel
{
	freshload = false;
	// channel is the morphmixer channel
	setdesc(SCRIPTNAME);
	channelNames[1] = "Rotation.H";
	channelNames[2] = "Rotation.P";
	channelNames[3] = "Rotation.B";
	curtime = Scene().currenttime;
	targetName = "";
}


process: ca, frame, time
{
	if(freshload)
	{
		freshLoadCheck();
		targetName = selObj.name;
		freshload = false;
	}
	curtime = time;
	if(selObj)
	{
		tv = selObj.getRotation(time);
		if(selChannel == 1)
			targetValue = tv.x;
		if(selChannel == 2)
			targetValue = tv.y;
		if(selChannel == 3)
			targetValue = tv.z;
			
//		targetValue = deg(chan.value(time));

		if(midState)
		{
			if(overshootState)
			{
				if(min < max)
				{
					if(targetValue <= mid && targetValue != 0.0)
						v = (targetValue / (mid - min)) / 2;
					if(targetValue == 0.0)
						v = 0.0;
					if(targetValue > mid)
						v = (targetValue - mid) / (max - mid) / 2 + .5;
				}
				if(min > max)
				{
					if(targetValue >= mid && targetValue != 0.0)
						v = (targetValue / (mid - min)) / 2;
					if(targetValue == 0.0)
						v = 0.0;
					if(targetValue < mid)
						v = (targetValue - mid) / (max - mid) / 2 + .5;
				}
			}
			if(!overshootState)
			{
				if(min < max)
				{
					if(targetValue <= mid && targetValue > min)
						v = ((targetValue - min) / (mid - min)) / 2;
					if(targetValue == 0.0)
						v = 0.0;
					if(targetValue > mid && targetValue <= max)
						v = ((targetValue - mid) / (max - mid)) *.5 + .5;
				}
				if(min > max)
				{
					if(targetValue >= mid && targetValue < min)
						v = ((targetValue - min) / (mid - min)) / 2;
					if(targetValue == 0.0)
						v = 0.0;
					if(targetValue < mid && targetValue >= max)
						v = ((targetValue - mid) / (max - mid)) *.5 + .5;
				}
			}
		}
		else
		{
			if(overshootState)
				v = targetValue / (max - min);
			else
			{
				if(min < max)
				{
					if(targetValue <= min)
						v = 0.0;
					if(targetValue >= max)
						v = 1.0;
					if(targetValue > min && targetValue < max)
						v = (targetValue - min) / (max - min);
				}
				if(min > max)
				{
					if(targetValue >= min)
						v = 0.0;
					if(targetValue <= max)
						v = 1.0;
					if(targetValue < min && targetValue > max)
						v = (targetValue - min) / (max - min);
				}
			}
		}
		if(v)
			ca.set(v);
	}
}
refreshMin: val
{
	min = getvalue(e1);
	if(min != 0.0)
	{
		overshootState = true;
		setvalue(c4,1);
	}
	a = getvalue(e2);
	if(val == a )
		setvalue(e2,a + 1);
}
refreshMid: val
{
	mid = getvalue(e2);
	a = getvalue(e1);
	b = getvalue(e3);
	if(val == a)
		setvalue(e1,a - 1);
	if(val == b)
		setvalue(e3,b + 1);
}
refreshMax: val
{
	max = getvalue(e3);
	a = getvalue(e2);
	if(val == a)
		setvalue(e2,a - 1);
}
midStateUDF: val
{
	midState = val;
}
midActive: val
{
	return(val);
}
overshootUDF: val
{
	overshootState = val;
}
recMin
{
	setvalue(e1,targetValue);
	requpdate();
}
recMid
{
	setvalue(e2,targetValue);
}
recMax
{
	setvalue(e3,targetValue);
}

targetRefresh: val
{
	selObj = val;
	if(val)
	{
		targetName = val.name;
		setvalue(a1,targetName);
	}
	else
	{
		targetName = "";
		setvalue(a1," ");
	}
	setdesc(SCRIPTNAME," - - >",targetName);
}
selChannelRefresh: val
{
	selChannel = val;
}
stringInactive: val
{
	return(false);
}
options
{
	reqbegin("Morph Driver");
	reqsize(210,225);
	a1 = ctlstring("Current",targetName);
	c1 = ctlallitems("Target",selObj);
	c2 = ctlpopup("Channels",selChannel,channelNames);
	c4 = ctlstate("Enable Overshooting",1,150,"overshootUDF");
	c3 = ctlstate("Enable Mid Values",1,150,"midStateUDF");

	e1 = ctlnumber("Min",min);
	e2 = ctlnumber("Mid",mid);
	e3 = ctlnumber("Max",max);
	
	d1 = ctlbutton("Rec Item",80,"recMin");
	d2 = ctlbutton("Rec Item",80,"recMid");
	d3 = ctlbutton("Rec Item",80,"recMax");
	ctlposition(d1,125,125);
	ctlposition(d2,125,149);
	ctlposition(d3,125,173);
	
	f1 = ctlcheckbox("",0);
	ctlposition(f1,500,500);
	
	ctlrefresh(c1,"targetRefresh");
	ctlrefresh(c2,"selChannelRefresh");
	ctlrefresh(e1,"refreshMin");
	ctlrefresh(e2,"refreshMid");
	ctlrefresh(e3,"refreshMax");
	ctlactive(f1,"stringInactive",a1);
	ctlactive(c3,"midActive",e2);
	setvalue(c3,midState);
	setvalue(c4,overshootState);

	reqopen();

/*
	if(selObj)
	{
		chan = selObj.firstChannel();
		while(chan)
		{
			if(chan.name == channelNames[selChannel])
				break;
			else
				chan = selObj.nextChannel();
		}
	}
*/

}
freshLoadCheck
{
	if(meshName)
	{
		if(targetID)
		{
			m = Mesh(meshName);
			mBone = m.bone();
			while(mBone)
			{
				if(mBone.id == targetID)
				{
					selObj = mBone;
					break;
				}
				mBone = mBone.next();
			}
		}
	}
	else
	{
		if(targetID)
		{
			mesh = Mesh();
			while(mesh)
			{
				if(mesh.id == targetID)
				{
					selObj = mesh;
					found = true;
					break;
				}
				mesh = mesh.next();
			}
			if(!found)
			{
				light = Light();
				while(light)
				{
					if(light.id == targetID)
					{
						selObj = light;
						found = true;
						break;
					}
				}
				light = light.next();
			}
			if(!found)
			{
				camera = Camera();
				while(camera)
				{
					if(camera.id == targetID)
					{
						selObj = camera;
						found = true;
						break;
					}
				}
			}
		}
	}
}
